* Generic session options - page and line size, no page breaks;
OPTIONS nonumber nodate nocenter pagesize=MAX linesize=120 formdlim=' ';											
* Kill default titles on output; 
TITLE;

* Location for original SAS files for these models;
%GLOBAL example; %LET example = F:\Example Data\Chapter 3 Data\Six-Occasion;
LIBNAME example "&example.";
	
* Defining global variable for datafile name to be replaced in code below;
%GLOBAL datafile; %LET datafile=Example3b;

* Bringing data into work library;
DATA &datafile.; SET example.&datafile.; RUN;

* Transposing to multivariate to correlate over time;
PROC TRANSPOSE DATA=&datafile. OUT=&datafile._multiv PREFIX=nm3rt;		
	BY ID;			* Transpose per unique value of BY;													
	ID session;		* Variable to define new columns;																	
	VAR nm3rt;		* Variable in old rows;					
RUN;

PROC MEANS DATA=&datafile.; VAR nm3rt; RUN;

* Actual data;
PROC CORR COV DATA=&datafile._multiv; VAR nm3rt1-nm3rt6; RUN;
PROC MEANS MEAN STDERR DATA=&datafile._multiv; VAR nm3rt1-nm3rt6; RUN;

TITLE "SAS Saturated Means, CS and Unstructured Variances Model via GLM";
TITLE2 "RM ANOVA";
PROC GLM DATA=&datafile._multiv;
	MODEL nm3rt1-nm3rt6 = / SOLUTION NOUNI;
	REPEATED session / PRINTE PRINTM;
RUN; QUIT;

TITLE1 "SAS: Saturated Means, VC Variances Model";
TITLE2 "Between-Person Independent ANOVA";
PROC MIXED DATA=&datafile. NOCLPRINT NOITPRINT COVTEST METHOD=REML;
	CLASS ID session;
	MODEL nm3rt = session / SOLUTION DDFM=BW;
	REPEATED session / R RCORR TYPE=VC SUBJECT=ID; 
	LSMEANS session / ; RUN;

TITLE1 "SAS: Saturated Means, CS Variances Model";
TITLE2 "Univariate Repeated Measures ANOVA";
PROC MIXED DATA=&datafile. NOCLPRINT NOITPRINT COVTEST METHOD=REML;
	CLASS ID session;
	MODEL nm3rt = session / SOLUTION DDFM=BW;
	REPEATED session / R RCORR TYPE=CS SUBJECT=ID; 
	LSMEANS session / ; RUN;

TITLE1 "SAS: Saturated Means, Unstructured Variances Model";
TITLE2 "Multivariate Repeated Measures ANOVA";
PROC MIXED DATA=&datafile. NOCLPRINT NOITPRINT COVTEST METHOD=REML;
	CLASS ID session;
	MODEL nm3rt = session / SOLUTION DDFM=BW;
	REPEATED session / R RCORR TYPE=UN SUBJECT=ID;
	LSMEANS session /; RUN;


******************************************************************************
****** 			BASELINE MLM/ANOVA LONGITUIDNAL MODELS					******
******************************************************************************;

* BP ANOVA;
TITLE1 "SAS: Saturated Means, E-Only Variances Model via GLM";
TITLE2 "BP ANOVA";
PROC GLM DATA=&datafile.;
	CLASS session;
	MODEL nm3rt =  session / SOLUTION;
	LSMEANS session / STDERR;
RUN; QUIT;

TITLE1 "SAS: Saturated Means, E-Only Variances Model via MIXED";
PROC MIXED DATA=&datafile. NOCLPRINT NOITPRINT COVTEST METHOD=REML;
	CLASS ID session;
	MODEL nm3rt = session / SOLUTION DDFM=Satterthwaite;
	REPEATED session / R TYPE=VC SUBJECT=ID; 
	LSMEANS session /; RUN;

* RM ANOVA -- first create multivariate dataset;
PROC TRANSPOSE DATA=&datafile. OUT=&datafile._multiv PREFIX=nm3rt;
	BY ID;
	ID Session;
	VAR nm3rt;
RUN;
TITLE "SAS Saturated Means, CS and Unstructured Variances Model via GLM";
TITLE2 "RM ANOVA";
PROC GLM DATA=&datafile._multiv;
	MODEL nm3rt1-nm3rt6 = / SOLUTION NOUNI;
	REPEATED session / PRINTE PRINTM;
RUN; QUIT;

TITLE1 "SAS: Saturated Means, CS Variances Model";
TITLE2 "Univariate RM ANOVA";
PROC MIXED DATA=&datafile. NOCLPRINT NOITPRINT COVTEST METHOD=REML;
	CLASS ID session;
	MODEL nm3rt = session / SOLUTION DDFM=Satterthwaite;
	REPEATED session / R RCORR TYPE=CS SUBJECT=ID; 
	LSMEANS session / ; RUN;

TITLE1 "SAS: Saturated Means, Unstructured Variances Model";
TITLE2 "Multivariate RM ANOVA";
PROC MIXED DATA=&datafile. NOCLPRINT NOITPRINT COVTEST METHOD=REML;
	CLASS ID session;
	MODEL nm3rts = session / SOLUTION DDFM=Satterthwaite;
	REPEATED session / R RCORR TYPE=UN SUBJECT=ID;
	LSMEANS session /; RUN;




